// IDA.idc
//
//    TFiler
//
// 20.05.2005

#include <idc.idc>
#include <D:\Programs\IDAidc\DelphiStructure.idc>

static Struct_TFiler()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TFiler";
	STRUCTURE_PARENT = "TObject_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TObject();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x4);
	AddStrucMember(sHandle, "FStream",		0x04, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FBuffer",		0x08, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FBufSize",		0x0C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FBufPos",		0x10, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FBufEnd",		0x14, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FRoot",		0x18, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FLookupRoot",		0x1C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"20",		0x20, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"24",		0x24, FF_DWRD, -1, 4);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_0", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_4", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_8", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_C", Address, -1);	}
	return sHandle;
}

static Struct_TReader()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TReader";
	STRUCTURE_PARENT = "TFiler_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TFiler();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "TFiler",		0x00, FF_STRU, sHandle_TObject, 0x28);
	AddStrucMember(sHandle, NAME+"4",		0x04, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"8",		0x08, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"C",		0x0C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"10",		0x10, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"14",		0x14, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"18",		0x18, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1C",		0x1C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"20",		0x20, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"24",		0x24, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FOwner",		0x28, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2C",		0x2C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"30",		0x30, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FLoaded",		0x34, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"38",		0x38, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"3C",		0x3C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"40",		0x40, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"44",		0x44, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"48",		0x48, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"4C",		0x4C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"50",		0x50, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"54",		0x54, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"58",		0x58, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"5C",		0x5C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"60",		0x60, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"64",		0x64, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"68",		0x68, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"6C",		0x6C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"70",		0x70, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FFinder",		0x74, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"78",		0x78, FF_DWRD, -1, 4);

	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_0", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_4", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_8", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_C", Address, -1);
		Address=0x10; AddConstEx(ID, NAME+"_10", Address, -1);
		Address=0x14; AddConstEx(ID, NAME+"_14", Address, -1);
		Address=0x18; AddConstEx(ID, NAME+"_18", Address, -1);
		Address=0x1C; AddConstEx(ID, NAME+"_1C", Address, -1);
		Address=0x20; AddConstEx(ID, NAME+"_20", Address, -1);
		Address=0x24; AddConstEx(ID, NAME+"_ReadPrefix", Address, -1);
	}
	return sHandle;
}


static main()
{
	Struct_TFiler();
	Struct_TReader();
}
