// IDA.idc
//
//    TStream
//
// 20.05.2005

#include <idc.idc>
#include <D:\Programs\IDAidc\DelphiStructure.idc>

static Struct_TStream()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;
	STRUCTURE_PARENT = "TObject_obj";
	STRUCTURE_NAME = "TStream_obj";
	EnumName="EnumTStream";

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TObject();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_DWRD, -1, 4);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, "TStream_0", Address, -1);
		Address=0x04; AddConstEx(ID, "TStream_4", Address, -1);
		Address=0x08; AddConstEx(ID, "TStream_Read", Address, -1);
		Address=0x0C; AddConstEx(ID, "TStream_C", Address, -1);
		Address=0x10; AddConstEx(ID, "TStream_10", Address, -1);
		Address=0x14; AddConstEx(ID, "TStream_14", Address, -1);
		Address=0x18; AddConstEx(ID, "TStream_18", Address, -1);	}
	return sHandle;
}

static Struct_TCustomMemoryStream()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;
	STRUCTURE_PARENT = "TStream_obj";
	STRUCTURE_NAME = "TCustomMemoryStream_obj";
	EnumName="EnumTCustomMemoryStream";

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TStream();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FMemory",		0x04, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "FSize",		0x08, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "TCustomMemoryStreamC",		0x0C, FF_DWRD, -1, 4);

	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, "TCustomMemoryStream_0", Address, -1);
		Address=0x04; AddConstEx(ID, "TCustomMemoryStream_4", Address, -1);
		Address=0x08; AddConstEx(ID, "TCustomMemoryStream_8", Address, -1);
		Address=0x0C; AddConstEx(ID, "TCustomMemoryStream_C", Address, -1);
		Address=0x10; AddConstEx(ID, "TCustomMemoryStream_10", Address, -1);
		Address=0x14; AddConstEx(ID, "TCustomMemoryStream_14", Address, -1);
		Address=0x18; AddConstEx(ID, "TCustomMemoryStream_18", Address, -1);	}
	return sHandle;
}

static Struct_TResourceStream()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TResourceStream";
	STRUCTURE_PARENT = "TCustomMemoryStream_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TCustomMemoryStream();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x10);
	AddStrucMember(sHandle, NAME+"4",		0x04, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"8",		0x08, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"C",		0x0C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "HResInfo",		0x10, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, "HGlobal",		0x14, FF_DWRD, -1, 4);

	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_0", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_4", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_8", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_C", Address, -1);
		Address=0x10; AddConstEx(ID, NAME+"_10", Address, -1);
		Address=0x14; AddConstEx(ID, NAME+"_14", Address, -1);
		Address=0x18; AddConstEx(ID, NAME+"_18", Address, -1);	}
	return sHandle;
}


static main()
{
	Struct_TStream();
	Struct_TCustomMemoryStream();
	Struct_TResourceStream();
}
