// IDA.idc
//
//    TWinControl
//
// 20.05.2005

#include <idc.idc>
#include <D:\Programs\IDAidc\DelphiStructure.idc>

static Struct_TWinControl()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TWinControl";
	STRUCTURE_PARENT = "TControl_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TControl();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x15C);
	AddStrucMember(sHandle, NAME+"160",		0x160, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"164",		0x164, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"168",		0x168, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"16C",		0x16C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"170",		0x170, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"174",		0x174, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"178",		0x178, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"17C",		0x17C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"180",		0x180, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"184",		0x184, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"188",		0x188, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"18C",		0x18C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"190",		0x190, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"194",		0x194, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"198",		0x198, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"19C",		0x19C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1A0",		0x1A0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1A4",		0x1A4, FF_BYTE, -1, 1);
	AddStrucMember(sHandle, "Showing",		0x1A6, FF_BYTE, -1, 1);
	AddStrucMember(sHandle, NAME+"1A8",		0x1A8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1AC",		0x1AC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1B0",		0x1B0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1B4",		0x1B4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1B8",		0x1B8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1BC",		0x1BC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1C0",		0x1C0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1C4",		0x1C4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1C8",		0x1C8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1CC",		0x1CC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1D0",		0x1D0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1D4",		0x1D4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1D8",		0x1D8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1DC",		0x1DC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1E0",		0x1E0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1E4",		0x1E4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1E8",		0x1E8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1EC",		0x1EC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1F0",		0x1F0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1F4",		0x1F4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1F8",		0x1F8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"1FC",		0x1FC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"200",		0x200, FF_DWRD, -1, 4);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_00", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_04", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_08", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_0C", Address, -1);	
		Address=0x10; AddConstEx(ID, NAME+"_10", Address, -1);
		Address=0x14; AddConstEx(ID, NAME+"_14", Address, -1);
		Address=0x18; AddConstEx(ID, NAME+"_18", Address, -1);
		Address=0x2C; AddConstEx(ID, NAME+"_1C", Address, -1);
		Address=0x20; AddConstEx(ID, NAME+"_20", Address, -1);
		Address=0x24; AddConstEx(ID, NAME+"_24", Address, -1);
		Address=0x28; AddConstEx(ID, NAME+"_28", Address, -1);
		Address=0x2C; AddConstEx(ID, NAME+"_2C", Address, -1);
		Address=0x30; AddConstEx(ID, NAME+"_30", Address, -1);
		Address=0x34; AddConstEx(ID, NAME+"_34", Address, -1);
		Address=0x38; AddConstEx(ID, NAME+"_38", Address, -1);
		Address=0x3C; AddConstEx(ID, NAME+"_3C", Address, -1);
		Address=0x40; AddConstEx(ID, NAME+"_40", Address, -1);
		Address=0x44; AddConstEx(ID, NAME+"_44", Address, -1);
		Address=0x48; AddConstEx(ID, NAME+"_48", Address, -1);
		Address=0x4C; AddConstEx(ID, NAME+"_4C", Address, -1);
		Address=0x50; AddConstEx(ID, NAME+"_50", Address, -1);
		Address=0x54; AddConstEx(ID, NAME+"_54", Address, -1);
		Address=0x58; AddConstEx(ID, NAME+"_58", Address, -1);
		Address=0x5C; AddConstEx(ID, NAME+"_5C", Address, -1);
		Address=0x60; AddConstEx(ID, NAME+"_60", Address, -1);
		Address=0x64; AddConstEx(ID, NAME+"_64", Address, -1);
		Address=0x68; AddConstEx(ID, NAME+"_68", Address, -1);
		Address=0x6C; AddConstEx(ID, NAME+"_6C", Address, -1);
		Address=0x70; AddConstEx(ID, NAME+"_70", Address, -1);
		Address=0x74; AddConstEx(ID, NAME+"_74", Address, -1);
		Address=0x78; AddConstEx(ID, NAME+"_78", Address, -1);
		Address=0x7C; AddConstEx(ID, NAME+"_7C", Address, -1);
		Address=0x80; AddConstEx(ID, NAME+"_80", Address, -1);
		Address=0x84; AddConstEx(ID, NAME+"_84", Address, -1);
		Address=0x88; AddConstEx(ID, NAME+"_88", Address, -1);
		Address=0x8C; AddConstEx(ID, NAME+"_8C", Address, -1);
		Address=0x90; AddConstEx(ID, NAME+"_90", Address, -1);
		Address=0x94; AddConstEx(ID, NAME+"_94", Address, -1);
		Address=0x98; AddConstEx(ID, NAME+"_98", Address, -1);
		Address=0x9C; AddConstEx(ID, NAME+"_9C", Address, -1);
		Address=0xA0; AddConstEx(ID, NAME+"_A0", Address, -1);
		Address=0xA4; AddConstEx(ID, NAME+"_A4", Address, -1);
		Address=0xA8; AddConstEx(ID, NAME+"_A8", Address, -1);
		Address=0xAC; AddConstEx(ID, NAME+"_AC", Address, -1);
		Address=0xB0; AddConstEx(ID, NAME+"_B0", Address, -1);
		Address=0xB4; AddConstEx(ID, NAME+"_B4", Address, -1);
		Address=0xB8; AddConstEx(ID, NAME+"_B8", Address, -1);
		Address=0xBC; AddConstEx(ID, NAME+"_BC", Address, -1);
		Address=0xC0; AddConstEx(ID, NAME+"_C0", Address, -1);
	}
	return sHandle;
}

static Struct_TScrollingWinControl()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TScrollingWinControl";
	STRUCTURE_PARENT = "TWinControl_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TWinControl();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x204);
	AddStrucMember(sHandle, NAME+"208",		0x208, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"20C",		0x20C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"210",		0x210, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"214",		0x214, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"218",		0x218, FF_DWRD, -1, 4);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_00", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_04", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_08", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_0C", Address, -1);	
		Address=0x10; AddConstEx(ID, NAME+"_10", Address, -1);
		Address=0x14; AddConstEx(ID, NAME+"_14", Address, -1);
		Address=0x18; AddConstEx(ID, NAME+"_18", Address, -1);
		Address=0x2C; AddConstEx(ID, NAME+"_1C", Address, -1);
		Address=0x20; AddConstEx(ID, NAME+"_20", Address, -1);
		Address=0x24; AddConstEx(ID, NAME+"_24", Address, -1);
		Address=0x28; AddConstEx(ID, NAME+"_28", Address, -1);
		Address=0x2C; AddConstEx(ID, NAME+"_2C", Address, -1);
		Address=0x30; AddConstEx(ID, NAME+"_30", Address, -1);
		Address=0x34; AddConstEx(ID, NAME+"_34", Address, -1);
		Address=0x38; AddConstEx(ID, NAME+"_38", Address, -1);
		Address=0x3C; AddConstEx(ID, NAME+"_3C", Address, -1);
		Address=0x40; AddConstEx(ID, NAME+"_40", Address, -1);
		Address=0x44; AddConstEx(ID, NAME+"_44", Address, -1);
		Address=0x48; AddConstEx(ID, NAME+"_48", Address, -1);
		Address=0x4C; AddConstEx(ID, NAME+"_4C", Address, -1);
		Address=0x50; AddConstEx(ID, NAME+"_50", Address, -1);
		Address=0x54; AddConstEx(ID, NAME+"_54", Address, -1);
		Address=0x58; AddConstEx(ID, NAME+"_58", Address, -1);
		Address=0x5C; AddConstEx(ID, NAME+"_5C", Address, -1);
		Address=0x60; AddConstEx(ID, NAME+"_60", Address, -1);
		Address=0x64; AddConstEx(ID, NAME+"_64", Address, -1);
		Address=0x68; AddConstEx(ID, NAME+"_68", Address, -1);
		Address=0x6C; AddConstEx(ID, NAME+"_6C", Address, -1);
		Address=0x70; AddConstEx(ID, NAME+"_70", Address, -1);
		Address=0x74; AddConstEx(ID, NAME+"_74", Address, -1);
		Address=0x78; AddConstEx(ID, NAME+"_78", Address, -1);
		Address=0x7C; AddConstEx(ID, NAME+"_7C", Address, -1);
		Address=0x80; AddConstEx(ID, NAME+"_80", Address, -1);
		Address=0x84; AddConstEx(ID, NAME+"_84", Address, -1);
		Address=0x88; AddConstEx(ID, NAME+"_88", Address, -1);
		Address=0x8C; AddConstEx(ID, NAME+"_8C", Address, -1);
		Address=0x90; AddConstEx(ID, NAME+"_90", Address, -1);
		Address=0x94; AddConstEx(ID, NAME+"_94", Address, -1);
		Address=0x98; AddConstEx(ID, NAME+"_98", Address, -1);
		Address=0x9C; AddConstEx(ID, NAME+"_9C", Address, -1);
		Address=0xA0; AddConstEx(ID, NAME+"_A0", Address, -1);
		Address=0xA4; AddConstEx(ID, NAME+"_A4", Address, -1);
		Address=0xA8; AddConstEx(ID, NAME+"_A8", Address, -1);
		Address=0xAC; AddConstEx(ID, NAME+"_AC", Address, -1);
		Address=0xB0; AddConstEx(ID, NAME+"_B0", Address, -1);
		Address=0xB4; AddConstEx(ID, NAME+"_B4", Address, -1);
		Address=0xB8; AddConstEx(ID, NAME+"_B8", Address, -1);
		Address=0xBC; AddConstEx(ID, NAME+"_BC", Address, -1);
		Address=0xC0; AddConstEx(ID, NAME+"_C0", Address, -1);
		Address=0xC4; AddConstEx(ID, NAME+"_C4", Address, -1);
		Address=0xC8; AddConstEx(ID, NAME+"_C8", Address, -1);
		Address=0xCC; AddConstEx(ID, NAME+"_CC", Address, -1);
	}
	return sHandle;
}

static Struct_TCustomForm()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TCustomForm";
	STRUCTURE_PARENT = "TScrollingWinControl_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TScrollingWinControl();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "",			0x00, FF_STRU, sHandle_TObject, 0x21C);
	AddStrucMember(sHandle, NAME+"220",		0x220, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"224",		0x224, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"228",		0x228, FF_BYTE, -1, 1);
	AddStrucMember(sHandle, "FWindowState",		0x22B, FF_BYTE, -1, 1);
	AddStrucMember(sHandle, NAME+"22C",		0x22C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"230",		0x230, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"234",		0x234, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"238",		0x238, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"23C",		0x23C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"240",		0x240, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"244",		0x244, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"248",		0x248, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"24C",		0x24C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"250",		0x250, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"254",		0x254, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"258",		0x258, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"25C",		0x25C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"260",		0x260, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"264",		0x264, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"268",		0x268, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"26C",		0x26C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"270",		0x270, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"274",		0x274, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"278",		0x278, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"27C",		0x27C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"280",		0x280, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"284",		0x284, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"288",		0x288, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"28C",		0x28C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"290",		0x290, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"294",		0x294, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"298",		0x298, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"29C",		0x29C, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2A0",		0x2A0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2A4",		0x2A4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2A8",		0x2A8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2AC",		0x2AC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2B0",		0x2B0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2B4",		0x2B4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2B8",		0x2B8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2BC",		0x2BC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2C0",		0x2C0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2C4",		0x2C4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2C8",		0x2C8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2CC",		0x2CC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2D0",		0x2D0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2D4",		0x2D4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2D8",		0x2D8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2DC",		0x2DC, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2E0",		0x2E0, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2E4",		0x2E4, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2E8",		0x2E8, FF_DWRD, -1, 4);
	AddStrucMember(sHandle, NAME+"2EC",		0x2EC, FF_DWRD, -1, 4);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_00", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_04", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_08", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_0C", Address, -1);	
		Address=0x10; AddConstEx(ID, NAME+"_10", Address, -1);
		Address=0x14; AddConstEx(ID, NAME+"_14", Address, -1);
		Address=0x18; AddConstEx(ID, NAME+"_18", Address, -1);
		Address=0x2C; AddConstEx(ID, NAME+"_1C", Address, -1);
		Address=0x20; AddConstEx(ID, NAME+"_20", Address, -1);
		Address=0x24; AddConstEx(ID, NAME+"_24", Address, -1);
		Address=0x28; AddConstEx(ID, NAME+"_28", Address, -1);
		Address=0x2C; AddConstEx(ID, NAME+"_2C", Address, -1);
		Address=0x30; AddConstEx(ID, NAME+"_30", Address, -1);
		Address=0x34; AddConstEx(ID, NAME+"_34", Address, -1);
		Address=0x38; AddConstEx(ID, NAME+"_38", Address, -1);
		Address=0x3C; AddConstEx(ID, NAME+"_3C", Address, -1);
		Address=0x40; AddConstEx(ID, NAME+"_40", Address, -1);
		Address=0x44; AddConstEx(ID, NAME+"_44", Address, -1);
		Address=0x48; AddConstEx(ID, NAME+"_48", Address, -1);
		Address=0x4C; AddConstEx(ID, NAME+"_4C", Address, -1);
		Address=0x50; AddConstEx(ID, NAME+"_50", Address, -1);
		Address=0x54; AddConstEx(ID, NAME+"_54", Address, -1);
		Address=0x58; AddConstEx(ID, NAME+"_58", Address, -1);
		Address=0x5C; AddConstEx(ID, NAME+"_5C", Address, -1);
		Address=0x60; AddConstEx(ID, NAME+"_60", Address, -1);
		Address=0x64; AddConstEx(ID, NAME+"_64", Address, -1);
		Address=0x68; AddConstEx(ID, NAME+"_68", Address, -1);
		Address=0x6C; AddConstEx(ID, NAME+"_6C", Address, -1);
		Address=0x70; AddConstEx(ID, NAME+"_70", Address, -1);
		Address=0x74; AddConstEx(ID, NAME+"_74", Address, -1);
		Address=0x78; AddConstEx(ID, NAME+"_78", Address, -1);
		Address=0x7C; AddConstEx(ID, NAME+"_7C", Address, -1);
		Address=0x80; AddConstEx(ID, NAME+"_80", Address, -1);
		Address=0x84; AddConstEx(ID, NAME+"_84", Address, -1);
		Address=0x88; AddConstEx(ID, NAME+"_88", Address, -1);
		Address=0x8C; AddConstEx(ID, NAME+"_8C", Address, -1);
		Address=0x90; AddConstEx(ID, NAME+"_90", Address, -1);
		Address=0x94; AddConstEx(ID, NAME+"_94", Address, -1);
		Address=0x98; AddConstEx(ID, NAME+"_98", Address, -1);
		Address=0x9C; AddConstEx(ID, NAME+"_9C", Address, -1);
		Address=0xA0; AddConstEx(ID, NAME+"_A0", Address, -1);
		Address=0xA4; AddConstEx(ID, NAME+"_A4", Address, -1);
		Address=0xA8; AddConstEx(ID, NAME+"_A8", Address, -1);
		Address=0xAC; AddConstEx(ID, NAME+"_AC", Address, -1);
		Address=0xB0; AddConstEx(ID, NAME+"_B0", Address, -1);
		Address=0xB4; AddConstEx(ID, NAME+"_B4", Address, -1);
		Address=0xB8; AddConstEx(ID, NAME+"_B8", Address, -1);
		Address=0xBC; AddConstEx(ID, NAME+"_BC", Address, -1);
		Address=0xC0; AddConstEx(ID, NAME+"_C0", Address, -1);
		Address=0xC4; AddConstEx(ID, NAME+"_C4", Address, -1);
		Address=0xC8; AddConstEx(ID, NAME+"_C8", Address, -1);
		Address=0xCC; AddConstEx(ID, NAME+"_CC", Address, -1);
		Address=0xD0; AddConstEx(ID, NAME+"_D0", Address, -1);
		Address=0xD4; AddConstEx(ID, NAME+"_D4", Address, -1);
		Address=0xD8; AddConstEx(ID, NAME+"_D8", Address, -1);
		Address=0xDC; AddConstEx(ID, NAME+"_DC", Address, -1);
		Address=0xE0; AddConstEx(ID, NAME+"_E0", Address, -1);
		Address=0xE4; AddConstEx(ID, NAME+"_E4", Address, -1);
		Address=0xE8; AddConstEx(ID, NAME+"_E8", Address, -1);
		Address=0xEC; AddConstEx(ID, NAME+"_EC", Address, -1);
	}
	return sHandle;
}

static Struct_TForm()
{
auto	sHandle, sHandle_TObject;
auto	error;
auto	NAME, STRUCTURE_NAME, STRUCTURE_PARENT;
auto ID, Address;
auto EnumName;

// Init Data
	NAME = "TForm";
	STRUCTURE_PARENT = "TCustomForm_obj";
	STRUCTURE_NAME = NAME+"_obj";
	EnumName="Enum"+NAME;

	//     ,    
	sHandle_TObject = GetStrucIdByName(STRUCTURE_PARENT);
	if(sHandle_TObject == -1)
	{	sHandle_TObject = Struct_TCustomForm();	} // ************** !!!!!!!!!!!!!!!

	sHandle = AddStrucEx(-1, STRUCTURE_NAME, 0);
	if(sHandle == -1)
	{	sHandle = GetStrucIdByName(STRUCTURE_NAME);
		if(sHandle == -1)
		{	WarningMessage("Unable to create the " + STRUCTURE_NAME + " structure!\n");
			return -1;	}
		return sHandle;		}
		
	AddStrucMember(sHandle, "pVTBL",		0x00, FF_STRU, sHandle_TObject, 0x2F0);
	ID=AddEnum(0, EnumName, 0);
	if (ID != -1)
	{	Address=0x00; AddConstEx(ID, NAME+"_00", Address, -1);
		Address=0x04; AddConstEx(ID, NAME+"_04", Address, -1);
		Address=0x08; AddConstEx(ID, NAME+"_08", Address, -1);
		Address=0x0C; AddConstEx(ID, NAME+"_0C", Address, -1);	
		Address=0x10; AddConstEx(ID, NAME+"_10", Address, -1);
		Address=0x14; AddConstEx(ID, NAME+"_14", Address, -1);
		Address=0x18; AddConstEx(ID, NAME+"_18", Address, -1);
		Address=0x2C; AddConstEx(ID, NAME+"_1C", Address, -1);
		Address=0x20; AddConstEx(ID, NAME+"_20", Address, -1);
		Address=0x24; AddConstEx(ID, NAME+"_24", Address, -1);
		Address=0x28; AddConstEx(ID, NAME+"_28", Address, -1);
		Address=0x2C; AddConstEx(ID, NAME+"_2C", Address, -1);
		Address=0x30; AddConstEx(ID, NAME+"_30", Address, -1);
		Address=0x34; AddConstEx(ID, NAME+"_34", Address, -1);
		Address=0x38; AddConstEx(ID, NAME+"_38", Address, -1);
		Address=0x3C; AddConstEx(ID, NAME+"_3C", Address, -1);
		Address=0x40; AddConstEx(ID, NAME+"_40", Address, -1);
		Address=0x44; AddConstEx(ID, NAME+"_44", Address, -1);
		Address=0x48; AddConstEx(ID, NAME+"_48", Address, -1);
		Address=0x4C; AddConstEx(ID, NAME+"_4C", Address, -1);
		Address=0x50; AddConstEx(ID, NAME+"_50", Address, -1);
		Address=0x54; AddConstEx(ID, NAME+"_54", Address, -1);
		Address=0x58; AddConstEx(ID, NAME+"_58", Address, -1);
		Address=0x5C; AddConstEx(ID, NAME+"_5C", Address, -1);
		Address=0x60; AddConstEx(ID, NAME+"_60", Address, -1);
		Address=0x64; AddConstEx(ID, NAME+"_64", Address, -1);
		Address=0x68; AddConstEx(ID, NAME+"_68", Address, -1);
		Address=0x6C; AddConstEx(ID, NAME+"_6C", Address, -1);
		Address=0x70; AddConstEx(ID, NAME+"_70", Address, -1);
		Address=0x74; AddConstEx(ID, NAME+"_74", Address, -1);
		Address=0x78; AddConstEx(ID, NAME+"_78", Address, -1);
		Address=0x7C; AddConstEx(ID, NAME+"_7C", Address, -1);
		Address=0x80; AddConstEx(ID, NAME+"_80", Address, -1);
		Address=0x84; AddConstEx(ID, NAME+"_84", Address, -1);
		Address=0x88; AddConstEx(ID, NAME+"_88", Address, -1);
		Address=0x8C; AddConstEx(ID, NAME+"_8C", Address, -1);
		Address=0x90; AddConstEx(ID, NAME+"_90", Address, -1);
		Address=0x94; AddConstEx(ID, NAME+"_94", Address, -1);
		Address=0x98; AddConstEx(ID, NAME+"_98", Address, -1);
		Address=0x9C; AddConstEx(ID, NAME+"_9C", Address, -1);
		Address=0xA0; AddConstEx(ID, NAME+"_A0", Address, -1);
		Address=0xA4; AddConstEx(ID, NAME+"_A4", Address, -1);
		Address=0xA8; AddConstEx(ID, NAME+"_A8", Address, -1);
		Address=0xAC; AddConstEx(ID, NAME+"_AC", Address, -1);
		Address=0xB0; AddConstEx(ID, NAME+"_B0", Address, -1);
		Address=0xB4; AddConstEx(ID, NAME+"_B4", Address, -1);
		Address=0xB8; AddConstEx(ID, NAME+"_B8", Address, -1);
		Address=0xBC; AddConstEx(ID, NAME+"_BC", Address, -1);
		Address=0xC0; AddConstEx(ID, NAME+"_C0", Address, -1);
		Address=0xC4; AddConstEx(ID, NAME+"_C4", Address, -1);
		Address=0xC8; AddConstEx(ID, NAME+"_C8", Address, -1);
		Address=0xCC; AddConstEx(ID, NAME+"_CC", Address, -1);
		Address=0xD0; AddConstEx(ID, NAME+"_D0", Address, -1);
		Address=0xD4; AddConstEx(ID, NAME+"_D4", Address, -1);
		Address=0xD8; AddConstEx(ID, NAME+"_D8", Address, -1);
		Address=0xDC; AddConstEx(ID, NAME+"_DC", Address, -1);
		Address=0xE0; AddConstEx(ID, NAME+"_E0", Address, -1);
		Address=0xE4; AddConstEx(ID, NAME+"_E4", Address, -1);
		Address=0xE8; AddConstEx(ID, NAME+"_E8", Address, -1);
		Address=0xEC; AddConstEx(ID, NAME+"_EC", Address, -1);
	}
	return sHandle;
}


static main()
{
//	Struct_TWinControl();
//	Struct_TScrollingWinControl();
//	Struct_TCustomForm();
	Struct_TForm();
}
